#!/bin/sh
# File: e16-desktop-convert.sh
# by ^thehatsrule^ for use with e16 on DSL
# to integrate xtdesktop's icons entries into the e16 menu

INSTALL_DIR="${HOME}/.e16/menus"
INSTALL_MENU_NAME="dsl_desktop"
INSTALL_FNAME="${INSTALL_DIR}/${INSTALL_MENU_NAME}.menu"
MENU_NAME="DSL Desktop"
if ! [ -e "${INSTALL_DIR}" ]; then
  printf "Creating ${INSTALL_DIR}...\n"
  mkdir -p "${INSTALL_DIR}"
fi
if ! [ -d "${INSTALL_DIR}" ]; then
  printf "Error on using ${INSTALL_DIR}\n"
  exit 1
fi

if ! [ -e "${INSTALL_FNAME}" ]; then
  touch "${INSTALL_FNAME}"
  if [ $? -eq 0 ]; then
    printf "\"${MENU_NAME}\"\n" > "${INSTALL_FNAME}"
  fi
fi

if ! [ -w "${INSTALL_FNAME}" -a -r "${INSTALL_FNAME}" ]; then
  printf "${INSTALL_FNAME} not rw.\n"
  exit 1
fi

cd ~/.xtdesktop
IFS="
"

for eachlnk in `ls *.lnk`
do
  printf "Converting: ${eachlnk} "
  for eachline in `cat ${eachlnk} `
  do
    case "${eachline}" in
      *Caption:* )
          _Name=`printf "${eachline}"|cut -d' ' -f 4- `
          ;;
      *Command:* )
          _Exec=`printf "${eachline}"|cut -d' ' -f 4- `
          ;;
    esac
    printf "."

  done

  printf " "

  if [ -n "${_Name}" -a -n "${_Exec}" ]; then
    LINE_TO_ADD="\"${_Name}\" NULL exec \"${_Exec}\""
    grep "${LINE_TO_ADD}" "${INSTALL_FNAME}" >/dev/null

    if [ $? -ne 0 ]; then
      printf "${LINE_TO_ADD}\n" >> ${INSTALL_FNAME}
      printf "${_Name} Added\n" 
    else
      printf "Skipping, ${_Name} already exists\n" 
    fi

  else
    printf "Skipping, Name or Exec not found."
  fi
  unset _Name _Exec

done

ADD_TO_FILE_MENU="${INSTALL_DIR}/file.menu"
if  [ -w "${ADD_TO_FILE_MENU}" -a -r "${ADD_TO_FILE_MENU}" ]; then
  LINE_TO_ADD_2="\"${MENU_NAME}\" NULL menu \"menus/${INSTALL_MENU_NAME}.menu\""
  grep "${LINE_TO_ADD_2}" "${ADD_TO_FILE_MENU}" >/dev/null

  if [ $? -eq 0 ]; then
    printf "Already added ${INSTALL_MENU_NAME} entry to ${ADD_TO_FILE_MENU}\n"
  else
    printf "Adding ${INSTALL_MENU_NAME}.menu to ${ADD_TO_FILE_MENU}\n"

    FIRST_LINE=1
    for eachline in `cat ${ADD_TO_FILE_MENU}`
    do

      if [ ${FIRST_LINE} -eq 1 ]; then
        printf "${eachline}\n${LINE_TO_ADD_2}\n" > ${ADD_TO_FILE_MENU}
        FIRST_LINE=0
      else
        printf "${eachline}\n" >> ${ADD_TO_FILE_MENU}
      fi

    done
  fi

else
  printf "${ADD_TO_FILE_MENU} not found or rw.\n"
fi

